function kn = linearTE( Nx, Ny);

global ks ind kn Ny Nx E dx dy ind Hr

handle=findobj('Tag','osax');
Nx=str2num(get(handle,'String'));

handle=findobj('Tag','osay');
Ny=str2num(get(handle,'String'));


a  = 22.86e-3;                % ka vlnovodu
b  = 10.16e-3;                % vka vlnovodu

dx = ones(1,Nx) * (a/Nx);     % vektory rozmr k.p.
dy = ones(1,Ny) * (b/Ny);

Q1 = [  0  0  0;  0  1 -1;  0 -1  1] / 2;
Q3 = [  1 -1  0; -1  1  0;  0  0  0] / 2;
Te = [  2  1  1;  1  2  1;  1  1  2] /12;

N  = 2 * Nx * Ny;             % celkov poet k.p.
St = sparse( 3*N, 3*N);       % matice pro izolovan k.p.
Tt = sparse( 3*N, 3*N);

n = 0;
for ny=1:Ny
  for nx=1:Nx
    n  = n + 1;
    lw = 3*n-2;
    hg = 3*n;
    St(lw:hg,lw:hg) = Q1 * dx(nx)/dy(ny) + Q3 * dy(ny)/dx(nx);
    Tt(lw:hg,lw:hg) = Te * dx(nx)*dy(ny)/2;
    St(lw+3*Nx:hg+3*Nx,lw+3*Nx:hg+3*Nx) = St(lw:hg,lw:hg);
    Tt(lw+3*Nx:hg+3*Nx,lw+3*Nx:hg+3*Nx) = Tt(lw:hg,lw:hg);
  end
  n = n + Nx;
end

C = get_c1( Nx, Ny, N);

S = C'*St*C; 
T = C'*Tt*C;

clear C St Tt

[H,K] = eig( full(S), full(T));
kn  = sqrt( diag( K));

[kmin,imin] = min( kn);               % eliminace "nulovho" vidu
kr       = [kn(1:imin-1,1); kn(imin+1:size(kn,1),1)];
Hr       = [H(:,1:imin-1), H(:,imin+1:size(kn,1))];
[ks,ind] = sort( kr);

vidyte;
